import rdf, string

S, P, O = 0, 1, 2

Article = rdf.Article
parse = rdf.parse
query = rdf.query

def nquery(s, x): 
   s = parse(s)[0]
   return query(s, x)

def u(uri): 
   """Create a resource article from a URI.
      i.e. Put angular brackets around a string."""
   return '<'+uri+'>'

def b(label=''): 
   if label == '': 
      import random # 208,827,064,576 combinations
      for x in range(8): label += string.lowercase[random.randrange(0, 25)]
      return '_:'+label
   else: return '_:'+label

def l(s): return '"'+s+'"'

def serialize(triples): 
   result = ''
   for triple in triples: 
      result += '%s %s %s .\n' % (triple[S], triple[P], triple[O])
   return result.rstrip()

def nt2xmlrdf(ntriples): 
   return serializeXML(parse(ntriples))

def serializeXML(triples): # TODO
   S, P, O, URI, ANON, LIT = 0, 1, 2, 'URI', 'Exivar', 'Literal'
   xrdf = '<rdf:RDF xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">\n'
   for t in triples:
      for x in (S, P, O):
         if '#' in t[x].v: 
            term, txmlns = t[x].v, t[x].v.split('#')[0]+'#'
            tname = t[x].v.split('#')[1]
         else: term, txmlns, tname = t[x].v, t[x].v[:-1], t[x].v[-1]
         if x == S and t[x].t == URI: 
            xrdf += '<rdf:Description rdf:about="'+term+'"/>\n'
         elif x == S and t[x].t == ANON: xrdf += '<rdf:Description>\n'
         elif x == S and t[x].t == LIT: # @@ encoding
            xrdf += '<rdf:Description rdf:about="data:,'+term+'">\n'
         elif x == P and t[x].t == URI:
            xrdf += '   <'+tname+' xmlns="'+txmlns+'"'
            blargh = tname[:]
         elif x == P and t[x].t == ANON:
            sys.stderr.write('Kaboom!') # i.e. not implementable
            xrdf += '   <'+term+' xmlns="anon:_" \n' # A new URI Scheme...
         elif x == P and t[x].t == LIT: raise 'Literal as predicate'
         elif x == O and t[x].t == URI: 
            xrdf += '\n     rdf:resource="'+term+'"/>\n'
         elif x == O and t[x].t == ANON:
            xrdf += '\n     rdf:resource="anon:_'+term+'"/>\n'
         elif x == O and t[x].t == LIT: # This is a hack
            if blargh: xrdf += '>'+term+'</'+blargh+'>\n'
            else: xrdf += '\n  rdf:resource="data:,'+term+'"/>\n'
      xrdf += '</rdf:Description>\n'
   return xrdf + '</rdf:RDF>'

class Namespace: 
    def __init__(self, ns='', sep=''): 
       self.ns, self.sep = ns, sep
    def __getattr__(self, name): 
       return self.ns+self.sep+name

if __name__=="__main__": 
   print serialize(parse('<p> _:q ?r .\n "x"\t"y" <#z> . '))